<md-dialog class="styled-modal">
    <form class="form-validation styled-modal__form" name="widget_form" ng-submit="updateUser(); UtilService.untouchForm(profile_form)" ng-cloak>
        <md-toolbar class="modal-header">
            <div class="md-toolbar-tools modal-header__wrapper">
                <h2 id="modalTitle" class="modal-header__title"><span ng-if="card.stepCount">{{card.stepCount}}/2</span> {{card.title}}</h2>
                <span flex></span>
                <md-button id="close" class="md-icon-button _default-md-style" data-ng-click="cancel()">
                    <md-icon aria-label="Close dialog">close</md-icon>
                </md-button>
            </div>
        </md-toolbar>
    <md-dialog-content class="modal-content">
        <div class="md-dialog-content modal-content__wrapper">
            <div ng-show="card.id === 'choose'" class="inputs-group w-divider _no-wrap _mobile-wrap">
                <md-input-container class="search-input _search">
                    <label class="placeholder-label">Search</label>
                    <input name="search" type="search" ng-model="sc[card.scValue]" ng-model-options="{debounce: 700}" autocomplete="off"/>
                    <md-icon class="input-search-icon search-input__icon">search</md-icon>
                    <md-icon class="input-close-icon search-input__icon" ng-click="clearSearch()">close</md-icon>
                </md-input-container>
                <div class="buttons-wrapper">
                    <md-button ng-click="getCardById('choose')"
                        type="button"
                        class="button-rounded pull-right"
                        ng-class="{'_selected': card.index === 1}">
                        <md-icon class="material-icons" role="img" aria-label="autorenew">collections</md-icon>
                        Templates
                    </md-button>
                </div>
            </div>
        <div class="selection-blocks_container_elements" ng-switch="card.index">
            <div ng-switch-when="1" class="card-wrapper">
                <zf-radio-button class="selection-blocks_container_elements_item" ng-repeat="template in templates | filter:sc track by template.id" on-change="onChange();" ng-model="widget.widgetTemplate" value="template">
                    <zf-radio-button-body>
                        <div class="selection-blocks_container_elements_item_container">
                            <div class="selection-blocks_container_elements_item_container_title"><show-part text="::template.name" limit="50"></show-part></div>
                            <div class="selection-blocks_container_elements_item_container_description"><show-part text="::template.description" limit="110"></show-part></div>
                        </div>
                        <div class="selection-blocks_container_elements_item_icon" ng-switch="::template.type">
                            <md-icon ng-switch-when="PIE" md-svg-src="../../../../assets/images/pie_chart.svg"></md-icon>
                            <md-icon ng-switch-when="BAR" md-svg-src="../../../../assets/images/bar_chart.svg"></md-icon>
                            <md-icon ng-switch-when="TABLE" md-svg-src="../../../../assets/images/table_chart.svg"></md-icon>
                            <md-icon ng-switch-when="LINE" md-svg-src="../../../../assets/images/line_chart.svg"></md-icon>
                            <md-icon ng-switch-default md-svg-src="../../../../assets/images/default_chart.svg"></md-icon>
                        </div>
                        <div class="selection-blocks_container_elements_item_preview" ng-switch="::template.type">
                            <img ng-switch-when="PIE" class="card__icon {{template.type.toLowerCase()}}" src="../../../../assets/images/pie.svg" alt="pie">
                            <img ng-switch-when="BAR" class="card__icon {{template.type.toLowerCase()}}" src="../../../../assets/images/bar.svg" alt="bar">
                            <img ng-switch-when="TABLE" class="card__icon {{template.type.toLowerCase()}}" src="../../../../assets/images/table.svg" alt="table"></img>
                            <img ng-switch-when="LINE" class="card__icon {{template.type.toLowerCase()}}" src="../../../../assets/images/line.svg" alt="line"></img>
                            <img ng-switch-default class="card__icon {{template.type.toLowerCase()}}" src="../../../../assets/images/default.svg" alt="default"></img>
                        </div>
                    </zf-radio-button-body>
                </zf-radio-button>
            </div>
            <div ng-switch-when="3" class="card-settings">
                <div class="inputs-group w-divider">
                    <div class="widget-wizard_container-helper_picture">
                        <div class="widget-wizard_container-helper_picture_item item-{{widget.widgetTemplate.type.toLowerCase()}}" ng-if="widget.data && widget.data.dataset && widget.data.dataset.length">
                            <div id="chart" data-echarts dataset="getWidgetDataset(widget)" ng-if="widget.widgetTemplate.type !== 'TABLE'" force-watch="true" with-legend="false" chart-actions="chartActions" config="echartConfig" data-options="widget.widgetTemplate.model" data-config-callback="onOptionsLoaded(arg1);" style="height: 179px; width: 280px;"></div>
                            <table class="table table-striped table-bordered table-hover" ng-if="widget.widgetTemplate.type === 'TABLE'" ng-init="onOptionsLoaded(widget.widgetTemplate.model);" style="width: 100%;">
                                <thead>
                                    <tr>
                                        <th class="pointer" ng-show="!widgetBuilder.legendConfigObject.legendItems || widgetBuilder.legendConfigObject.legendItems[column] === undefined || widgetBuilder.legendConfigObject.legendItems[column]" data-ng-repeat="column in widget.widgetTemplate.model.columns">
                                            {{column}}&nbsp;<i class="fa fa-sort"></i>
                                        </th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr data-ng-repeat="row in widget.data.dataset | orderBy:sort.column:sort.descending">
                                        <td ng-show="!widgetBuilder.legendConfigObject.legendItems || widgetBuilder.legendConfigObject.legendItems[column] === undefined || widgetBuilder.legendConfigObject.legendItems[column]" data-ng-repeat="column in widget.widgetTemplate.model.columns" data-ng-bind-html="asString(row[column])" data-ng-style="widget.widgetTemplate.model.columns.length > 1 && {'max-width': '500px'}"></td>
                                    </tr>
                                    <tr class="text-center" data-ng-if="widget.data.dataset == 0">
                                        <td colspan="{{widget.widgetTemplate.model.columns.length}}">No data</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                        <div class="widget-wizard_container-helper_picture_caption" ng-if="widget.widgetTemplate.name">
                            {{widget.widgetTemplate.name}}
                        </div>
                        <div class="widget-wizard_container-helper_picture_description">
                            Preview
                        </div>
                        <div class="refresh-wrapper">
                            <md-button class="refresh-button" ng-click="buildConfigs(widget_form.params)">
                                <span class="material-icons refresh-button__icon">refresh</span>
                                <span class="refresh-button__text">Refresh</span>
                            </md-button>
                        </div>
                    </div>
                </div>
                <ng-form name="params">
                    <fieldset ng-disabled="widgetParamsLoadingInProgress">
                        <div class="inputs-group _wrap-items _margin-top">
                            <div class="input-size-m" ng-if="paramValue.required && ! paramValue.hidden" ng-repeat="(paramName, paramValue) in widgetBuilder.paramsConfigObject track by $index" ng-switch="paramValue.type">
                                <div class="input-size-m _margin-bottom" ng-switch-default>
                                    <md-input-container class="no-margin _gray-bg">
                                        <label>{{paramName.toLowerCase()}}</label>
                                        <input class="text-input" ng-attr-type="{{paramValue.type === 'int' ? 'number' : 'text'}}" ng-attr-name="{{paramName}}" ng-model="paramValue.value" ng-change="handleRequiredParamChange(widget_form.params, paramName.toLowerCase())" ng-required="true" ng-model-options="{debounce: 500}"/>
                                        <div ng-messages="widget_form.params[paramName].$error" ng-if="widget_form.params[paramName].$dirty">
                                            <div ng-message="required">{{paramName}} required</div>
                                        </div>
                                    </md-input-container>
                                </div>
                                <div layout="row" class="input-size-m _margin-bottom" ng-switch-when="array">
                                    <md-input-container class="no-margin">
                                        <label>{{paramName.toLowerCase()}}</label>
                                        <md-select ng-model="paramValue.value" ng-change="handleRequiredParamChange(widget_form.params, paramName.toLowerCase())" ng-if="paramValue.multiple !== true" ng-required="true" ng-disabled="widgetParamsLoadingInProgress">
                                            <md-option ng-repeat="val in paramValue.values" ng-value="val">
                                                {{val}}
                                            </md-option>
                                        </md-select>
                                        <md-select ng-model="paramValue.value" ng-change="handleRequiredParamChange(widget_form.params, paramName.toLowerCase())" ng-if="paramValue.multiple === true" ng-required="true" ng-disabled="widgetParamsLoadingInProgress" multiple>
                                            <md-option ng-repeat="val in paramValue.values" ng-value="val">
                                                {{val}}
                                            </md-option>
                                        </md-select>
                                    </md-input-container>
                                </div>
                                <div class="input-size-m _margin-bottom" ng-switch-when="radio">
                                    <md-input-container>
                                        <label class="radio-label">{{paramName.toLowerCase()}} *</label>
                                        <md-radio-group class="radio-group" ng-model="paramValue.value" ng-change="handleRequiredParamChange(widget_form.params, paramName.toLowerCase())" ng-disabled="widgetParamsLoadingInProgress">
                                            <md-radio-button class="radio-button" ng-value="val" ng-repeat="val in paramValue.values">{{val}}</md-radio-button>
                                        </md-radio-group>
                                    </md-input-container>
                                </div>
                                <div class="input-size-m _margin-bottom" ng-switch-when="title">
                                    <div class="zf-label">{{paramValue.value.toLowerCase()}}</div>
                                </div>
                            </div>
                        </div>
                    </fieldset>
                </ng-form>
                <ng-form name="notRequiredparams" ng-if="$ctrl.showAdvanced === true">
                    <fieldset ng-disabled="widgetParamsLoadingInProgress">
                        <div class="inputs-group _wrap-items _margin-top">
                            <div class="input-wrapper selection-blocks_container_elements_input type-{{paramValue.type}}" ng-if="! paramValue.required && ! paramValue.hidden  && ($ctrl.showAdvanced || paramValue.input_enabled || paramValue.oldValue)" ng-repeat="(paramName, paramValue) in widgetBuilder.paramsConfigObject track by $index" ng-switch="paramValue.type">
                                <div class="input-size-m" ng-class="{'_disable-grow': ['title'].indexOf(paramValue.type) === -1}" ng-switch-default>
                                    <md-input-container class="no-margin _gray-bg">
                                        <label>{{paramName.toLowerCase()}}</label>
                                        <input ng-attr-type="{{paramValue.type === 'int' ? 'number' : 'text'}}"
                                            class="text-input"
                                            ng-attr-name="{{paramName}}"
                                            ng-model="paramValue.value"
                                            ng-change="buildConfigs(widget_form.params)"
                                            ng-required="true"
                                            ng-disabled="! paramValue.input_enabled"
                                            placeholder=""/>
                                        <div ng-messages="widget_form.params[paramName].$error" ng-if="widget_form.params[paramName].$dirty">
                                            <div ng-message="required">{{paramName}} required</div>
                                        </div>
                                    </md-input-container>
                                </div>
                                <div class="input-size-m" ng-class="{'_disable-grow': ['title'].indexOf(paramValue.type) === -1}" ng-class="{'disable-grow': ['title'].indexOf(paramValue.type) === -1}" ng-switch-when="array">
                                    <md-input-container class="no-margin">
                                        <label>{{paramName.toLowerCase()}}</label>
                                        <md-select ng-model="paramValue.value" ng-change="buildConfigs(widget_form.params)" ng-if="paramValue.multiple !== true" ng-disabled="!paramValue.input_enabled || !paramValue.values.length" placeholder="">
                                            <md-option ng-repeat="val in paramValue.values" ng-value="val">
                                                {{val}}
                                            </md-option>
                                        </md-select>
                                        <md-select ng-model="paramValue.value" ng-change="buildConfigs(widget_form.params)" ng-if="paramValue.multiple === true" ng-disabled="!paramValue.input_enabled || !paramValue.values.length" placeholder="" multiple>
                                            <md-option ng-repeat="val in paramValue.values" ng-value="val">
                                                {{val}}
                                            </md-option>
                                        </md-select>
                                    </md-input-container>
                                </div>
                                <div class="input-size-m" ng-class="{'_disable-grow': ['title'].indexOf(paramValue.type) === -1}" ng-switch-when="radio">
                                    <md-input-container>
                                        <label class="radio-label">{{paramName.toLowerCase()}} *</label>
                                        <md-radio-group class="radio-group" ng-model="paramValue.value" ng-change="buildConfigs(widget_form.params)" ng-disabled="! paramValue.input_enabled">
                                            <md-radio-button class="radio-button" ng-value="val" ng-repeat="val in paramValue.values">{{val}}</md-radio-button>
                                        </md-radio-group>
                                    </md-input-container>
                                </div>
                                <div class="input-size-l" ng-switch-when="title">
                                    <div class="zf-label">{{paramValue.value.toLowerCase()}}</div>
                                </div>
                                <md-button ng-show="['title'].indexOf(paramValue.type) === -1" ng-init="paramValue.input_enabled" ng-disabled="!paramValue.values.length && paramValue.type === 'array' || widgetParamsLoadingInProgress" ng-click="paramValue.input_enabled = !paramValue.input_enabled; switchInputEnabled(paramValue); buildConfigs(widget_form.params);" aria-label="extended_switch" class="md-icon-button md-primary visibility-toggle">
                                    <md-icon md-svg-icon="visibleOnIcon" ng-if="paramValue.input_enabled" class="material-icons visibility-toggle__icon"></md-icon>
                                    <md-icon md-svg-icon="visibleOffIcon" ng-if="!paramValue.input_enabled" class="material-icons visibility-toggle__icon"></md-icon>
                                </md-button>
                            </div>
                        </div>
                    </fieldset>
                </ng-form>
                <div ng-if="$ctrl.needToLoadWidgetParams" class="selection-blocks_container_elements_show-more" md-no-ink>
                    <md-button class="md-primary" ng-click="getWidgetParams(widget_form.params)">
                        Refresh
                    </md-button>
                </div>
                <div ng-if="!$ctrl.needToLoadWidgetParams" class="selection-blocks_container_elements_show-more" md-no-ink>
                    <md-button ng-show="hasEmptyOptionalParams(false) && lastSelectedPeriod === widgetBuilder.paramsConfigObject.PERIOD.value" ng-disabled="widgetParamsLoadingInProgress" ng-click="$ctrl.changeAdvancedFlag()" class="md-primary">
                        Show <span ng-if="!$ctrl.showAdvanced">more</span><span ng-if="$ctrl.showAdvanced">less</span>
                    </md-button>
                </div>
            </div>
            <div ng-switch-when="4" class="card-settings">
                <div class="inputs-group w-divider">
                    <div class="widget-wizard_container-helper_picture">
                        <div class="widget-wizard_container-helper_picture_item item-{{widget.widgetTemplate.type.toLowerCase()}}" ng-if="widget.data && widget.data.dataset && widget.data.dataset.length">
                            <div id="chart" data-echarts dataset="getWidgetDataset(widget)" ng-if="widget.widgetTemplate.type !== 'TABLE'" force-watch="true" with-legend="false" chart-actions="chartActions" config="echartConfig" data-options="widget.widgetTemplate.model" data-config-callback="onOptionsLoaded(arg1);" style="height: 179px; width: 280px;"></div>
                            <table class="table table-striped table-bordered table-hover" ng-if="widget.widgetTemplate.type === 'TABLE'" ng-init="onOptionsLoaded(widget.widgetTemplate.model);" style="width: 100%;">
                                <thead>
                                    <tr>
                                        <th class="pointer" ng-show="!widgetBuilder.legendConfigObject.legendItems || widgetBuilder.legendConfigObject.legendItems[column] === undefined || widgetBuilder.legendConfigObject.legendItems[column]" data-ng-repeat="column in widget.widgetTemplate.model.columns">
                                            {{column}}&nbsp;<i class="fa fa-sort"></i>
                                        </th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr data-ng-repeat="row in widget.data.dataset | orderBy:sort.column:sort.descending">
                                        <td ng-show="!widgetBuilder.legendConfigObject.legendItems || widgetBuilder.legendConfigObject.legendItems[column] === undefined || widgetBuilder.legendConfigObject.legendItems[column]" data-ng-repeat="column in widget.widgetTemplate.model.columns" data-ng-bind-html="asString(row[column])" data-ng-style="widget.widgetTemplate.model.columns.length > 1 && {'max-width': '500px'}"></td>
                                    </tr>
                                    <tr class="text-center" data-ng-if="widget.data.dataset == 0">
                                        <td colspan="{{widget.widgetTemplate.model.columns.length}}">No data</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                        <div class="widget-wizard_container-helper_picture_caption" ng-if="widget.widgetTemplate.name">
                            {{widget.widgetTemplate.name}}
                        </div>
                        <div class="widget-wizard_container-helper_picture_description">
                            Preview
                        </div>
                    </div>
                </div>
                <div class="selection-blocks_container_elements_personal no-margin">
                    <ng-form class="form-validation" name="info">
                        <div class="selection-blocks_container_elements_personal_item input-size-m">
                            <md-input-container class="_gray-bg">
                                <label class="placeholder-label">Name</label>
                                <input type="text" name="title" data-ng-model="widget.title" placeholder="" autofocus required/>
                                <div ng-messages="widget_form.info.title.$error" ng-if="widget_form.info.title.$dirty">
                                    <div ng-message="required">Name required</div>
                                </div>
                            </md-input-container>
                        </div>
                        <div class="selection-blocks_container_elements_personal_item __description">
                            <md-input-container class="_gray-bg">
                                <label class="placeholder-label">Description</label>
                                <textarea name="description" class="form-control validation summary" rows="3" data-ng-model="widget.description" placeholder=""></textarea>
                            </md-input-container>
                        </div>
                    </ng-form>
                </div>
                <div class="selection-blocks_container_elements warning-block" ng-if="START_MODE === 'UPDATE' && dashboards.length">
                    <div class="selection-blocks_container_elements warning-block__body no-margin">
                        Warning! Any changes may cause loss of data. This widget is currently is in use on other dashboard(s).
                    </div>
                    <div class="selection-blocks_container_elements warning-block__list no-margin">
                        <span class="warning-block__listitem" ng-repeat="d in ::dashboards | orderBy: 'title' track by d.id">{{d.title}}</span>
                    </div>
                </div>
                <div class="selection-blocks_container_elements_additional" ng-if="widgetBuilder.legendConfigObject.legend">
                    <zf-input-container>
                        <label>Set legend</label>
                        <div class="selection-blocks_container_elements_additional_legend-container">
                            <div class="selection-blocks_container_elements_additional_legend-container_item" ng-repeat="legendName in widgetBuilder.legendConfigObject.legend track by $index">
                                <md-checkbox ng-model="widgetBuilder.legendConfigObject.legendItems[legendName]" ng-change="onLegendChange(legendName);" aria-label="checkbox">{{legendName}}</md-checkbox>
                            </div>
                        </div>
                    </zf-input-container>
                </div>
            </div>
        </div>
        </div>
    </md-dialog-content>
    <md-dialog-actions layout="row" class="styled-modal__controls-wrapper">
        <md-button class="md-raised" ng-click="back();" ng-if="isBackButtonPresent()">
            Back
        </md-button>
        <md-button class="md-raised md-primary pull-right" ng-click="next();" ng-if="isNextButtonPresent()" ng-disabled="card.nextDisabled(widget_form)">
            Next
        </md-button>
        <md-button class="md-raised md-primary pull-right" ng-click="createWidget();" ng-if="isLastCard() && ! widget.id" ng-disabled="widget_form.info.$invalid">
            Add
        </md-button>
        <md-button class="md-raised md-primary pull-right" ng-click="updateWidget();" ng-if="isLastCard() && widget.id && START_MODE === 'UPDATE'" ng-disabled="widget_form.info.$invalid">
            Save
        </md-button>
    </md-dialog-actions>
    </form>
</md-dialog>
